RootLoader (groovy 2.4.12 API)
Date: 2017-06-21

Package: org.codehaus.groovy.tools

## [Java] Class RootLoader

- org.codehaus.groovy.tools.RootLoader

- This ClassLoader should be used as root of class loaders. Any RootLoader does have it's own classpath. When searching for a class or resource this classpath will be used. Parent Classloaders are ignored first. If a class or resource can't be found in the classpath of the RootLoader, then parent is checked.

  Note: this is very against the normal behavior of classloaders. Normal is to first check parent and then look in the resources you gave this classloader.

  It's possible to add urls to the classpath at runtime through addURL(URL)

  Why using RootLoader? If you have to load classes with multiple classloaders and a classloader does know a class which depends on a class only a child of this loader does know, then you won't be able to load the class. To load the class the child is not allowed to redirect it's search for the class to the parent first. That way the child can load the class. If the child does not have all classes to do this, this fails of course.

  For example:

             parentLoader   (has classpath: a.jar;c.jar)
                 |
                 |
             childLoader    (has classpath: a.jar;b.jar;c.jar)

  class C (from c.jar) extends B (from b.jar) childLoader.find("C") --> parentLoader does know C.class, try to load it --> to load C.class it has to load B.class --> parentLoader is unable to find B.class in a.jar or c.jar --> NoClassDefFoundException! if childLoader had tried to load the class by itself, there would be no problem. Changing childLoader to be a RootLoader instance will solve that problem.
  Authors:
    Jochen Theodorou

- - ### Constructor Summary

    Constructors
    Constructor and description
    `RootLoader (URL[] urls, ClassLoader parent)` constructs a new RootLoader with a parent loader and an array of URLs as classpath
    `RootLoader (LoaderConfiguration lc)` constructs a new RootLoader with a LoaderConfiguration object which holds the classpath

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `addURL(URL url)` adds an url to the classpath of this classloader
    `` | `protected Class` | `findClass(String name)`
    `` | `URL` | `getResource(String name)` returns the URL of a resource, or null if it is not found
    `` | `protected Class` | `loadClass(String name, boolean resolve)` loads a class using the name of the class

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class URLClassLoader` | `getResourceAsStream, newInstance, newInstance, findResource, findResources, close, getURLs, loadClass, getSystemClassLoader, getResource, getSystemResource, getSystemResourceAsStream, clearAssertionStatus, getParent, getResources, getSystemResources, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class SecureClassLoader` | `loadClass, getSystemClassLoader, getResource, getResourceAsStream, getSystemResource, getSystemResourceAsStream, clearAssertionStatus, getParent, getResources, getSystemResources, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### public RootLoader(URL[] urls, ClassLoader parent)

      constructs a new RootLoader with a parent loader and an array of URLs as classpath

    - #### public RootLoader(LoaderConfiguration lc)

      constructs a new RootLoader with a LoaderConfiguration object which holds the classpath

  - ### Method Detail

    - #### public void addURL(URL url)

      adds an url to the classpath of this classloader

    - #### protected Class findClass(String name)

    - #### public URL getResource(String name)

      returns the URL of a resource, or null if it is not found

    - #### protected Class loadClass(String name, boolean resolve)

      loads a class using the name of the class